
\     19:42 26.03.2014
\     11:13 21.03.2014
\      9:08 19.03.2014
\     10:33 18.03.2014        
\     11:53 16.03.2014
\ chu 17:15 01.03.2014

  marker =nRF24L01+=

\ Pins

\  m328p
\  PORTD 4 portpin: nRF24_CE
\  PORTD 5 portpin: nRF24_CSN
\  PORTD 3 portpin: nRF24_IRQ     \ == INT1

\  m32A
  PORTC 2 portpin: nRF24_CE      \ Chip Enable Activates RX or TX mode
  PORTC 3 portpin: nRF24_CSN     \ SPI Chip Select 
  PORTD 3 portpin: nRF24_IRQ     \ == INT1
\
\     10:31 17.01.2014
\ chu 11:00 10.01.2014
\ ============================================================================
\
\  nRF24l01+  Register Map

 $00 constant nRF24_CONFIG        \ Configuration Register
 $01 constant nRF24_EN_AA         \ Enable Auto Acknowledgment
 $02 constant nRF24_EN_RXADDR     \ Enabled RX Addresses
 $03 constant nRF24_SETUP_AW      \ Setup of Address Widths (common for all data pipes)
 $04 constant nRF24_SETUP_RETR    \ Setup of Automatic Retransmission
 $05 constant nRF24_RF_CH         \ RF Channel
 $06 constant nRF24_RF_SETUP      \ RF Setup Register
 $07 constant nRF24_STATUS        \ Status Register (In parallel to the SPI command 
\ word applied on the MOSIpin, the STATUSregister is shifted serially out on the MISOpin)

 $08 constant nRF24_OBSERVE_TX    \ Transmit observe register
 $09 constant nRF24_CD            \ Carrier Detect. See page 74

\ Data pipes
 $0A constant nRF24_RX_ADDR_P0    \ 0xE7E7E7E7E7
 $0B constant nRF24_RX_ADDR_P1    \ 0xC2C2C2C2C2
 $0C constant nRF24_RX_ADDR_P2    \ 0xC3
 $0D constant nRF24_RX_ADDR_P3    \ 0xC4
 $0E constant nRF24_RX_ADDR_P4    \ 0xC5
 $0F constant nRF24_RX_ADDR_P5    \ 0xC6

 $10 constant nRF24_TX_ADDR       \ Transmit address.
\ Used for a PTX device only. (LSByte is written first)
\ Set RX_ADDR_P0 equal to this address to handle automatic acknowledge
\ if this is a PTX  device with Enhanced ShockBurst enabled. See page 65.


\ Number of bytes in RX payload in data pipe (1 to 32 bytes).
\ 0=Pipe not used 
 $11 constant nRF24_RX_PW_P0
 $12 constant nRF24_RX_PW_P1
 $13 constant nRF24_RX_PW_P2
 $14 constant nRF24_RX_PW_P3
 $15 constant nRF24_RX_PW_P4
 $16 constant nRF24_RX_PW_P5

 $17 constant nRF24_FIFO_STATUS   \ FIFO Status Register

 $1C constant nRF24_DYNPD         \ Enable dynamic payload length
 $1D constant nRF24_FEATURE       \ Feature Register

\ ========================================================================
\
\  some nRF24l01+ registers fields & constants

: bit  ( n --- m )  $7 and 1 swap lshift ;

  nRF24_STATUS     $70 bitmask: nrf24_flags
  nRF24_CONFIG   1 bit bitmask: radio-pw
  nRF24_CONFIG   0 bit bitmask: radio-rx
  nRF24_RF_CH      $7f bitmask: radio-ch
  nRF24_RF_SETUP 5 bit 3 bit or
                       bitmask: air-rate
  nRF24_SETUP_RETR $0f bitmask: arc
  nRF24_SETUP_RETR $f0 bitmask: ard
  nRF24_OBSERVE_TX $f0 bitmask: plos_cnt
  nRF24_OBSERVE_TX $0f bitmask: arc_cnt
  nRF24_RX_PW_P0   $3f bitmask: rx_pw \ Number of bytes in RX payload in data pipe


\ ========================================================================
\
\  nRF24L01+   commands

  $00 constant nRF24_REG@        \
  $20 constant nRF24_REG!        \
  $61 constant nRF24_RX_PLOAD@   \
  $a0 constant nRF24_TX_PLOAD!   \
  $e1 constant nRF24_FLUSH_TX    \
  $e2 constant nRF24_FLUSH_RX    \
  $e3 constant nRF24_REUSE_TX_PL \
  $ff constant nRF24_NOP         \

  $60 constant RX_PL_WID@        \
  $a1 constant ACK_PAYLOAD!      \ ( pipe --- )
  $b0 constant TX_PAYLOAD_NOACK! \

\ ========================================================================
\  base nRF24l01+ transactions over spi

  : nrf24?  ( -- n )        \ read nRF24L01+ STATUS

    nRF24_NOP
    nRF24_CSN low
    c!@spi 
    nRF24_CSN high
    ;


  : nrf24@  ( ra -- c )    \ ra -   nRF24, 1
          nRF24_REG@ or
          nRF24_CSN low
          spi! spi@
          nRF24_CSN high
          ;

  : nrf24!  ( c ra -- )
          nRF24_REG! or
          nRF24_CSN low
          spi! spi!
          nRF24_CSN high
          ;

  : nrf24-cmd! ( cmd --- )
    nRF24_CSN low  spi!
    nRF24_CSN high
    ;


  : nRF24_init
    
    nRF24_CSN over over pin_output high
    nRF24_CE  over over pin_output low
    +spi  0  spi-mode!
    nrf24_flags nrf24!
    ;

\
\ , ,  
\     r,
\ m - 
    
  : #bit+  ( m r --- )  dup >r nrf24@ or r> nrf24! ;    
  : #bit-  ( m r --- )  >r invert r@ nrf24@ and r> nrf24! ;
  : #tst?  ( m r --- f )  nrf24@  and ; 

\        m   r
  : #set+  ( c m r --- )
    dup  >r
    nrf24@
    over invert and
    >r   and
    r>   or  r>
    nrf24!
    ;

\ =====================================================================
\
\   

  : radio-pw?  ( -- f )  radio-pw #tst? ; \ power on?
  : radio-off  ( -- )    radio-pw #bit- ; \ power off
  : radio-on   ( -- )    radio-pw #bit+ pause 5 ms ; \ power up set bit

  : radio-ch!  ( n -- )  radio-ch #set+ ;
  : radio-ch@  ( -- n )  radio-ch #tst? ;

  : radio-rx?  ( -- f )  radio-rx #tst? ; \ test if receiver

  : radio-rx+         \ RX mode
    radio-rx #bit+    \ PRIM_RX set 1
    nRF24_CE high
    [ 130 us/ ]       \ RX setting
     literal ?delay
    ;

  : radio-tx+         \ TX mode
    nRF24_CE low
    radio-rx #bit-    \ clear PRIM_RX
    ; \ standby-I

  : cd?  ( -- f )  [ 0 bit ] literal nRF24_CD #tst? ; \ RPD


\
\ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\
\ Air data rate
\

  $0  constant 1Mbps
  $08 constant 2Mbps
  $20 constant 250Kbps

  : rf-rate! ( m -- )  air-rate #set+  ;
  : rf-rate@ ( -- m )  air-rate #tst?  ;

\
\ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\
\ Automatic Retransmission
\

  : retx-delay!  ( n --- )  4 lshift  ard #set+ ;
  : retx-delay@  ( --- n )  ard #tst? 4 rshift  ;

  : retx-count!  ( n --- )  arc #set+ ;
  : retx-count@  ( --- n )  arc #tst? ;

\
\ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\
\ nRF24_STATUS test

  \ Data pipe number for the payload available for reading from RX_FIFO
  \ 110: Not Used
  \ 111: RX FIFO Empty
  : rx-pipe? ( -- n )  nrf24? 1 rshift $7 and ; \ read only

  : tx-full? ( -- f )  nrf24? [ 0 bit ] literal  and ; \ read only

  : rx-data? ( -- f )  nrf24? [ 6 bit ] literal  and ; ( RX_DR  )
  : tx-sent? ( -- f )  nrf24? [ 5 bit ] literal  and ; ( TX_DS  )
  : rtx-max? ( -- f )  nrf24? [ 4 bit ] literal  and ; ( MAX_RT )

  : tx-end   ( -- f )  nrf24? [ 5 bit 4 bit or ] literal and ;

  : rx-done  ( -- ) [ 6 bit ] literal ( RX_DR  ) nRF24_STATUS #bit+ ;
  : tx-sent  ( -- ) [ 5 bit ] literal ( TX_DS  ) nRF24_STATUS #bit+ ;
  : rtx-fix  ( -- ) [ 4 bit ] literal ( MAX_RT ) nRF24_STATUS #bit+ ; 


\ nRF24_FIFO_STATUS 

  : rx-empty?  ( -- f ) [ 0 bit ] literal ( RX_EMPTY ) nRF24_FIFO_STATUS #tst? ;
  : tx-empty?  ( -- f ) [ 4 bit ] literal ( TX_EMPTY ) nRF24_FIFO_STATUS #tst? ;
 
\
\ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\ nRF24_OBSERVE_TX

  : tx-lost?   ( --- n )  plos_cnt #tst? &4 rshift ;
  : rtx-count? ( --- n )  arc_cnt  #tst? ;

\
\ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\
\ n==0..5 

  : ?pipe  dup 0 6 within 0= abort" illegal pipe#"  ; 

\ c==Number of bytes in RX payload in data pipe n1
  : pipe#?  ( n1 --- c )  ?pipe rx_pw rot + #tst? ;
  : pipe#!  ( c n1 --- )  ?pipe rx_pw rot + #set+ ;

\ Enabled RX Addresses
  : pipe    ( n --- m ra )  ?pipe bit nRF24_EN_RXADDR  ;
  : pipe+   ( n --- ) pipe #bit+ ; \ set
  : pipe-   ( n --- ) pipe #bit- ; \ clear
  : pipe?   ( n - f ) pipe #tst? ; \ test

\ Enable Auto Acknowledgment
  : auto-ack   ( n --- m ra )  ?pipe bit nRF24_EN_AA  ;
  : auto-ack+  ( n --- ) auto-ack #bit+ ;
  : auto-ack-  ( n --- ) auto-ack #bit- ;
  : auto-ack?  ( n - f ) auto-ack #tst? ;

 \ Enable dynamic payload length
  : dyn-pl    ( n --- m ra )  ?pipe bit nRF24_DYNPD  ;
  : dyn-pl+   ( n --- ) dyn-pl #bit+ ;
  : dyn-pl-   ( n --- ) dyn-pl #bit- ;
  : dyn-pl?   ( n - f ) dyn-pl #tst? ;

  : +dyn  [ 2 bit ] literal ( EN_DPL ) nRF24_FEATURE #bit+ ;
  : -dyn  [ 2 bit ] literal ( EN_DPL ) nRF24_FEATURE #bit- ;

\
\ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\ 
\ block transfers over spi

\
  : >spi  ( a c --- )  over + swap  ?do i c@ spi! loop  ;
  : <spi  ( a c --- )  over + swap  ?do spi@ i c! loop  ;


\ LSByte is first
  : <end  ( a c -- a1 c 0 )  dup -rot + swap 0 ;

  : spi<  ( a c --- )  <end ?do 1- dup  c@ spi! loop drop ;
  : spi>  ( a c --- )  <end ?do 1- spi@ over c! loop drop ;

\
\ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\
\ radio transceiver  addresses maintenance

\ LSByte is written first
\ a=address c=count ra=register_address

  : addrs!  ( a c ra --- )
    nRF24_CSN  low
    nRF24_REG! or spi! spi<
    nRF24_CSN  high
    ;
\ 
  : addrs@  ( a c ra --- )
    nRF24_CSN  low
    nRF24_REG@ or spi! spi>
    nRF24_CSN  high
    ;

\
\ Setup of Address Widths (common for all data pipes)

  : addrs_w!  ( n --- )
    dup 3 6 within 0= abort" illegal address width"
    2 - nRF24_SETUP_AW nrf24!
    ;

  : addrs_w@  ( --- n )
    nRF24_SETUP_AW  nrf24@  &3 and 2 +
    ;

\ 
         0
         5 -- transmitter
         5 -- receiver0
         5 -- receiver1
         1 -- receiver2
         1 -- receiver3
         1 -- receiver4
         1 -- receiver5
  constant   /addresses

  here dup /addresses dup allot 0 fill constant radio

  : ?receiver ( a1 #pipe -- a2 )
    case
    0 of receiver0 endof
    1 of receiver1 endof
    2 of receiver2 endof
    3 of receiver3 endof
    4 of receiver4 endof
    5 of receiver5 endof
    endcase
    ;

  : ?addr_w   ( #pipe -- aw )
    case
    0 2 range of addrs_w@ endof
    2 6 range of 1        endof
    endcase
    ;

    
\ Transmit address. Used for a PTX device only.
\ LSByte is written first

  : tx-addr!  ( a c --- ) \ ram version
    addrs_w@ over = 0= abort" wrong transmitter address width "
    nRF24_TX_ADDR addrs!
    ;

  : tx-addr@   radio transmitter addrs_w@ nRF24_TX_ADDR addrs@ ;

  : tx?addr.
    tx-addr@
    radio transmitter addrs_w@ over over
    over + swap do i c@ .x loop  
    2 spaces ." == " type cr
    ;


\ Receive address data # pipe
\ LSByte is written first.
\ Write the number of bytes defined by SETUP_AW

\   (   ) ,  >>addrs_w (SETUP_AW), 
\       addrs_w .
\     , 
\   SETUP_AW=5,
\                s" my_remote_node" 1 rx-addr! ,
\      nRF24_RX_ADDR_P1 == "_node"

  : rx-addr!  ( a c #pipe --- )

   ?pipe dup               ( a c # # )
    nRF24_RX_ADDR_P0 + >r  ( a c # | r: reg )
    ?addr_w
    over over < abort" too short address string" \ test if c < aw 
    >r ( a c | r: reg aw ) + r@ -
    r> r>  addrs!
    ;

  : rx-addr@  ( #pipe --- )
    
   ?pipe radio            ( # a1 )
    over ?receiver        ( # a2 )
    over ?addr_w          ( # a2 c )
    rot                   ( a2 c # )
    nRF24_RX_ADDR_P0 +    ( a2 c reg )
    addrs@
    ;

  : pipes?  6 0 do i rx-addr@ loop ;

  : pipes.
    radio 
    6 0 do
        i dup ." RX_ADDR_P" .x ." = "
        over over
        ?receiver over
        ?addr_w   over over
        over + swap do i c@ .x loop
        ." = " type cr drop
    loop
    drop
    ;

  : rx?addr.  pipes? pipes. ;

\
\ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\

  &32 constant #fifo  \   , 

\       

  here dup #fifo 1+ dup allot 0 fill ( erase ) constant rx-packet
  here dup #fifo 1+ dup allot 0 fill ( erase ) constant tx-packet

  : rx0buff    rx-packet #fifo 1+ 0  fill ; 
  : tx0buff    tx-packet #fifo 1+ 0  fill ;

\
\ =====================================================================
\
 
\ flush_tx     Delete all packets from the Tx FIFO.
  : tx0fifo   nRF24_FLUSH_TX nrf24-cmd! ;

\ flush_rx     Delete all packets from the Rx FIFO.
  : rx0fifo   nRF24_FLUSH_RX nrf24-cmd! ;

\ flush rx&tx fifos & clear all status flags
  : tr-clear
    nrf24_flags #bit+
    rx0fifo
    tx0fifo
    ;

\
\ =====================================================================
\
\  TX FIFO   
\ W_TX_PAYLOAD counted string at memory
\   c == 1..32

  : >tx-fifo   ( a c --- ) 
    nRF24_CSN low
    nRF24_TX_PLOAD! spi! >spi
    nRF24_CSN high
    ;

\  RX FIFO   
\ R_RX_PAYLOAD counted string at memory

  : <rx-fifo   ( a c --- ) 
    nRF24_CSN low
    nRF24_RX_PLOAD@ spi! <spi
    nRF24_CSN high
    ;

\ Reuse last transmitted payload.
\ TX payload reuse is active until W_TX_PAYLOAD or FLUSH TX is executed.
\ TX payload reuse must not be activated or deactivated during package transmission.

  : retx!    \ retransmit
    nRF24_REUSE_TX_PL nrf24-cmd!
    ;

\ Read RX payload width for the top 
\ R_RX_PAYLOADin the RX FIFO.
\ note: Flush RX FIFO if
\ the read value is larger than 32 bytes.

  : rx-count@  ( -- n )      \ packet-count@
    nRF24_CSN  low
    RX_PL_WID@ spi! spi@
    nRF24_CSN  high
    ;

\ Used in RX mode.
\ Write Payload to be transmitted together with 
\ ACK packet on PIPE n

  : >rx-ack+  ( a c n -- )   \ >packet-ack
    ?pipe
    nRF24_CSN  low
    ACK_PAYLOAD! or spi! >spi
    nRF24_CSN  high
    ;

\ Used in TX mode.
\ Disables AUTOACK on this specific packet.

  : >tx-noack  ( a c --- )   \ >packet-noack
    nRF24_CSN  low
    TX_PAYLOAD_NOACK! spi! >spi
    nRF24_CSN  high
    ;

\
\
  : startx
    nRF24_CE high [  10 us/ ] literal ?delay
    nRF24_CE low  [ 130 us/ ] literal ?delay
    ;

\ 
\ ==EOF===================================================================
\ occupys 2026 cells

